## org.eclipse.emf.cdo.server.db.mapping
Interface IMappingStrategy

    public interface IMappingStrategy

The mapping strategy acts as a connection between the DBStore and the database management (and OR-mapping) classes. The `DBStore` uses methods of this interface to create and lookup mappings (or mappers, as they could also be named as such) and to get properties and informations about the mappings used. The mapping classes (e.g., instances of IClassMapping and IListMapping) also use this class as a central point of information and as a resource of common functionalities.

Since:
  2.0

Field Summary
`static java.lang.String` `PROP_FORCE_NAMES_WITH_ID` Name of the boolean property that configures whether table names and column names are always suffixed with the internal DBID or only in cases where generated names violate the naming constraints of the underlying backend.
`static java.lang.String` `PROP_MAX_FIELD_NAME_LENGTH` Name of the integer property that configures the maximum length for column names.
`static java.lang.String` `PROP_MAX_TABLE_NAME_LENGTH` Name of the integer property that configures the maximum length for table names.
`static java.lang.String` `PROP_QUALIFIED_NAMES` Name of the boolean property that configures whether the table names are made of simple class names or of qualified class names.
`static java.lang.String` `PROP_TABLE_NAME_PREFIX` Name of the String property that specifies a common prefix for table names.

Method Summary
`IListMapping` `createListMapping(org.eclipse.emf.ecore.EClass containingClass, org.eclipse.emf.ecore.EStructuralFeature feature)` Factory for value mappings of multi-valued-attributes.
`void` `createMapping(java.sql.Connection connection, InternalCDOPackageUnit[] packageUnits, org.eclipse.net4j.util.om.monitor.OMMonitor monitor)` Create and initialize the mapping infrastructure for the given packages.
`ITypeMapping` `createValueMapping(org.eclipse.emf.ecore.EStructuralFeature feature)` Factory for value mappings of single-valued attributes.
`IClassMapping` `getClassMapping(org.eclipse.emf.ecore.EClass eClass)` Look up an existing class mapping for the given class.
`java.lang.String` `getFieldName(org.eclipse.emf.ecore.EStructuralFeature feature)` Create a suitable column name which can be used to map the given element.
`IDBStore` `getStore()`
`java.lang.String` `getTableName(org.eclipse.emf.ecore.EClass containingClass, org.eclipse.emf.ecore.EStructuralFeature feature)` Create a suitable table name which can be used to map the given element.
`java.lang.String` `getTableName(org.eclipse.emf.ecore.ENamedElement element)` Create a suitable table name which can be used to map the given element.
`boolean` `hasAuditSupport()` Query if this mapping supports audits.
`boolean` `hasDeltaSupport()` Query if this mapping supports revision deltas.
`void` `queryResources(IDBStoreAccessor dbStoreAccessor, IStoreAccessor.QueryResourcesContext context)` Execute a resource query.
`org.eclipse.net4j.util.collection.CloseableIterator<CDOID>` `readObjectIDs(IDBStoreAccessor dbStoreAccessor)` Get an iterator over all instances of objects in the store.
`CDOClassifierRef` `readObjectType(IDBStoreAccessor dbStoreAccessor, CDOID id)` Read the type (i.e. class) of the object referred to by a given ID.
`long` `repairAfterCrash(org.eclipse.net4j.db.IDBAdapter dbAdapter, java.sql.Connection connection)` Return the maximum object id used in the store.
`void` `setProperties(java.util.Map<java.lang.String,java.lang.String> properties)` Set configuration properties for this mapping strategy.
`void` `setStore(IDBStore dbStore)` Set the store to which this MappingStrategy instance belongs.

Field Detail

### PROP_MAX_TABLE_NAME_LENGTH

    static final java.lang.String PROP_MAX_TABLE_NAME_LENGTH

  Name of the integer property that configures the maximum length for table names. A value of zero indicates the value of the `db adapter` to be used.

  See Also:
    Constant Field Values

### PROP_MAX_FIELD_NAME_LENGTH

    static final java.lang.String PROP_MAX_FIELD_NAME_LENGTH

  Name of the integer property that configures the maximum length for column names. A value of zero indicates the value of the `db adapter` to be used.

  See Also:
    Constant Field Values

### PROP_TABLE_NAME_PREFIX

    static final java.lang.String PROP_TABLE_NAME_PREFIX

  Name of the String property that specifies a common prefix for table names.

  See Also:
    Constant Field Values

### PROP_QUALIFIED_NAMES

    static final java.lang.String PROP_QUALIFIED_NAMES

  Name of the boolean property that configures whether the table names are made of simple class names or of qualified class names.

  See Also:
    Constant Field Values

### PROP_FORCE_NAMES_WITH_ID

    static final java.lang.String PROP_FORCE_NAMES_WITH_ID

  Name of the boolean property that configures whether table names and column names are always suffixed with the internal DBID or only in cases where generated names violate the naming constraints of the underlying backend.

  See Also:
    Constant Field Values

Method Detail

### getStore

    IDBStore getStore()

  Returns:
    the store, this MappingStrategy instance belongs to.

### setStore

    void setStore(IDBStore dbStore)

  Set the store to which this MappingStrategy instance belongs. Should only be called by the `DBStore`, and only once to initialize the connection between `DBStore` and mapping strategy.

  Parameters:
    `dbStore` - the DBStore instance to which this MappingStrategy instance belongs.

### createValueMapping

    ITypeMapping createValueMapping(org.eclipse.emf.ecore.EStructuralFeature feature)

  Factory for value mappings of single-valued attributes.

  Parameters:
    `feature` - the feature for which a mapping should be created. It must hold `feature.isMany() == false`.
  Returns:
    the mapping created.

### createListMapping

    IListMapping createListMapping(org.eclipse.emf.ecore.EClass containingClass,
                                   org.eclipse.emf.ecore.EStructuralFeature feature)

  Factory for value mappings of multi-valued-attributes.

  Parameters:
    `containingClass` - the class containing the feature.
    `feature` - the feature for which a mapping should be created. It must hold `feature.isMany() == true`.
  Returns:

### getTableName

    java.lang.String getTableName(org.eclipse.emf.ecore.ENamedElement element)

  Create a suitable table name which can be used to map the given element. Should only be called by mapping classes.

  Parameters:
    `element` - the element for which the name should be created. It must hold: `element instanceof EClass || element instanceof EPackage`.
  Returns:
    the created table name. It is guaranteed that the table name is compatible with the chosen database.

### getTableName

    java.lang.String getTableName(org.eclipse.emf.ecore.EClass containingClass,
                                  org.eclipse.emf.ecore.EStructuralFeature feature)

  Create a suitable table name which can be used to map the given element. Should only be called by mapping classes. Should only be called by mapping classes.

  Parameters:
    `containingClass` - the class containeng the feature.
    `feature` - the feature for which the table name should be created.
  Returns:
    the created table name. It is guaranteed that the table name is compatible with the chosen database.

### getFieldName

    java.lang.String getFieldName(org.eclipse.emf.ecore.EStructuralFeature feature)

  Create a suitable column name which can be used to map the given element. Should only be called by mapping classes.

  Parameters:
    `feature` - the feature for which the column name should be created.
  Returns:
    the created column name. It is guaranteed that the name is compatible with the chosen database.

### createMapping

    void createMapping(java.sql.Connection connection,
                       InternalCDOPackageUnit[] packageUnits,
                       org.eclipse.net4j.util.om.monitor.OMMonitor monitor)

  Create and initialize the mapping infrastructure for the given packages. Should be called from the DBStore or the DBStoreAccessor.

  Parameters:
    `connection` - the connection to use.
    `packageUnits` - the packages whose elements should be mapped.
    `monitor` - the monitor to report progress.

### getClassMapping

    IClassMapping getClassMapping(org.eclipse.emf.ecore.EClass eClass)

  Look up an existing class mapping for the given class. Before this method is called, the class mapping must have been initialized by calling `createMapping(Connection, InternalCDOPackageUnit[], OMMonitor)` on its containing package.

  Parameters:
    `eClass` - the class to look up.
  Returns:
    the class mapping.

### hasDeltaSupport

    boolean hasDeltaSupport()

  Query if this mapping supports revision deltas.
  If this method returns `true`, it is guaranteed that all class mappings returned by `getClassMapping(EClass)` implement `IClassMappingDeltaSupport`.

  Returns:
    `true` if revision deltas are supported, `false` else.

### hasAuditSupport

    boolean hasAuditSupport()

  Query if this mapping supports audits.
  If this method returns `true`, it is guaranteed that all class mappings returned by `getClassMapping(EClass)` implement `IClassMappingAuditSupport`.

  Returns:
    `true` if audits are supported, `false` else.

### queryResources

    void queryResources(IDBStoreAccessor dbStoreAccessor,
                        IStoreAccessor.QueryResourcesContext context)

  Execute a resource query.

  Parameters:
    `dbStoreAccessor` - the accessor to use.
    `context` - the context from which the query parameters are read and to which the result is written.

### readObjectType

    CDOClassifierRef readObjectType(IDBStoreAccessor dbStoreAccessor,
                                    CDOID id)

  Read the type (i.e. class) of the object referred to by a given ID.

  Parameters:
    `dbStoreAccessor` - the accessor to use to look up the type.
    `id` - the ID of the object for which the type is to be determined.
  Returns:
    the type of the object.

### readObjectIDs

    org.eclipse.net4j.util.collection.CloseableIterator<CDOID> readObjectIDs(IDBStoreAccessor dbStoreAccessor)

  Get an iterator over all instances of objects in the store.

  Parameters:
    `dbStoreAccessor` - the accessor to use.
  Returns:
    the iterator.

### repairAfterCrash

    long repairAfterCrash(org.eclipse.net4j.db.IDBAdapter dbAdapter,
                          java.sql.Connection connection)

  Return the maximum object id used in the store. This is used by the DBStore if a previous crash is discovered during the startup process. Should only be called by the DBStore and only during startup.

  Parameters:
    `dbAdapter` - the dbAdapter to use to access the database
    `connection` - the connection to use to access the database
  Returns:
    the maximum object id used in the store.

### setProperties

    void setProperties(java.util.Map<java.lang.String,java.lang.String> properties)

  Set configuration properties for this mapping strategy. Should only be called by the factory creating the mapping strategy instance.

  Parameters:
    `properties` - the configuration properties to set.

Copyright (c) 2004 - 2009 Eike Stepper (Berlin, Germany) and others. All Rights Reserved.